# Generated by Django 4.2.15 on 2024-09-03 16:42

from django.db import migrations, models
import django.db.models.deletion
import inboxen.cms.fields
import inboxen.validators


def initial_data(apps, schema_editor):
    ContentType = apps.get_model("contenttypes.ContentType")

    AppPage = apps.get_model("cms.AppPage")
    HelpIndex = apps.get_model("cms.HelpIndex")

    help_index_ct, _ = ContentType.objects.get_or_create(model="helpindex", app_label="cms")
    app_page_ct, _ = ContentType.objects.get_or_create(model="apppage", app_label="cms")

    help_index = HelpIndex.objects.create(
        title="Help & Support",
        description="",
        content_type=help_index_ct,
        slug="help",
        live=True,
        lft=1,
        rght=4,
        level=0,
    )

    questions_app = AppPage.objects.create(
        title="Questions",
        description="If you need assistance or want to speak to a human.",
        content_type=app_page_ct,
        app="tickets.urls",
        slug="questions",
        live=True,
        in_menu=True,
        parent=help_index,
        lft=2,
        rght=3,
        level=1,
    )


def remove_initial_data(apps, schema_editor):
    HelpIndex = apps.get_model("cms.HelpIndex")
    AppPage = apps.get_model("cms.AppPage")

    HelpIndex.objects.all().delete()
    AppPage.objects.all().delete()


class Migration(migrations.Migration):

    replaces = [('cms', '0001_initial'), ('cms', '0002_auto_20170215_2100'), ('cms', '0003_helpindex_description'), ('cms', '0004_auto_20170218_2137'), ('cms', '0005_auto_20170226_2309'), ('cms', '0006_peoplepage_intro_paragraph'), ('cms', '0006_setup_helpsite'), ('cms', '0007_auto_20170916_1722'), ('cms', '0008_auto_20170916_2048'), ('cms', '0008_setup_helpsite'), ('cms', '0009_helpbasepage_url_cache'), ('cms', '0010_auto_20170917_1124'), ('cms', '0011_auto_20170925_1818'), ('cms', '0012_auto_20171231_1559'), ('cms', '0013_auto_20180105_1452'), ('cms', '0014_auto_20180116_2231'), ('cms', '0015_auto_20180315_1434'), ('cms', '0016_auto_20180607_2003'), ('cms', '0017_auto_20190501_2047'), ('cms', '0018_auto_20210913_2343'), ('cms', '0019_alter_helpbasepage_level_alter_helpbasepage_lft_and_more'), ('cms', '0020_remove_helpbasepage_tree_id_alter_helpbasepage_lft')]

    initial = True

    dependencies = [
        ("contenttypes", "0002_remove_content_type_name"),
    ]

    operations = [
        migrations.CreateModel(
            name="HelpBasePage",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("lft", models.PositiveIntegerField(db_index=True)),
                ("rght", models.PositiveIntegerField()),
                ("level", models.PositiveIntegerField()),
                (
                    "title",
                    models.CharField(
                        max_length=255,
                        validators=[
                            inboxen.validators.ProhibitNullCharactersValidator()
                        ],
                    ),
                ),
                (
                    "description",
                    models.TextField(
                        blank=True,
                        validators=[
                            inboxen.validators.ProhibitNullCharactersValidator()
                        ],
                    ),
                ),
                ("live", models.BooleanField(default=False)),
                ("in_menu", models.BooleanField(default=False)),
                (
                    "slug",
                    models.SlugField(
                        max_length=255,
                        validators=[
                            inboxen.validators.ProhibitNullCharactersValidator()
                        ],
                    ),
                ),
                (
                    "url_cache",
                    models.CharField(
                        default="",
                        max_length=255,
                        validators=[
                            inboxen.validators.ProhibitNullCharactersValidator()
                        ],
                    ),
                ),
                (
                    "content_type",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.PROTECT,
                        related_name="cms_pages",
                        to="contenttypes.contenttype",
                    ),
                ),
                (
                    "parent",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="children",
                        to="cms.helpbasepage",
                    ),
                ),
            ],
            options={
                "unique_together": {("slug", "parent")},
            },
        ),
        migrations.CreateModel(
            name="AppPage",
            fields=[
                (
                    "helpbasepage_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="cms.helpbasepage",
                    ),
                ),
                (
                    "app",
                    models.CharField(
                        choices=[("tickets.urls", "Tickets")],
                        max_length=255,
                        unique=True,
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("cms.helpbasepage",),
        ),
        migrations.CreateModel(
            name="HelpIndex",
            fields=[
                (
                    "helpbasepage_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="cms.helpbasepage",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("cms.helpbasepage",),
        ),
        migrations.CreateModel(
            name="HelpPage",
            fields=[
                (
                    "helpbasepage_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="cms.helpbasepage",
                    ),
                ),
                (
                    "body",
                    inboxen.cms.fields.RichTextField(
                        allow_tags=[
                            "p",
                            "a",
                            "i",
                            "b",
                            "em",
                            "strong",
                            "ol",
                            "ul",
                            "li",
                            "pre",
                            "code",
                            "h1",
                            "h2",
                            "h3",
                            "h4",
                            "h5",
                        ],
                        extensions=["markdown.extensions.toc"],
                        help_text="Markdown text, supports the TOC extension.",
                        safe_attrs=["href", "id"],
                        validators=[
                            inboxen.validators.ProhibitNullCharactersValidator()
                        ],
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("cms.helpbasepage",),
        ),
        migrations.CreateModel(
            name="PeoplePage",
            fields=[
                (
                    "helpbasepage_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="cms.helpbasepage",
                    ),
                ),
                (
                    "intro_paragraph",
                    inboxen.cms.fields.RichTextField(
                        blank=True,
                        help_text="Text at the top of the page. Supports standard markdown.",
                        validators=[
                            inboxen.validators.ProhibitNullCharactersValidator()
                        ],
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("cms.helpbasepage",),
        ),
        migrations.CreateModel(
            name="PersonInfo",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("ordinal", models.IntegerField(blank=True, editable=False, null=True)),
                (
                    "name",
                    models.CharField(
                        max_length=255,
                        validators=[
                            inboxen.validators.ProhibitNullCharactersValidator()
                        ],
                    ),
                ),
                (
                    "body",
                    inboxen.cms.fields.RichTextField(
                        validators=[
                            inboxen.validators.ProhibitNullCharactersValidator()
                        ]
                    ),
                ),
                (
                    "page",
                    models.ForeignKey(
                        editable=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="people",
                        to="cms.peoplepage",
                    ),
                ),
            ],
            options={
                "ordering": ["ordinal"],
            },
        ),
        migrations.RunPython(initial_data, remove_initial_data),
    ]
